import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {FinalSettle, FinalSettleParam} from './model';

/**
 * 分页查询结算
 */
export async function pageFinalSettle(params: FinalSettleParam) {
  const res = await request.get<ApiResult<PageResult<FinalSettle>>>(
    '/tower/tower-contract-final-settle/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listFinalSettle(params?: FinalSettleParam) {
  const res = await request.get<ApiResult<FinalSettle[]>>(
    '/tower/tower-contract-final-settle',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getFinalSettle(id: number) {
  const res = await request.get<ApiResult<FinalSettle>>(
    '/tower/tower-contract-final-settle/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addFinalSettle(data: FinalSettle) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateFinalSettle(data: FinalSettle) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchFinalSettle(data: FinalSettle[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchFinalSettle(data: FinalSettle[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeFinalSettle(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchFinalSettle(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
